Index: uspace/srv/net/tcp/service.c
===================================================================
--- uspace/srv/net/tcp/service.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/net/tcp/service.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup udp
+/** @addtogroup tcp
  * @{
  */
@@ -44,4 +44,5 @@
 #include <loc.h>
 #include <macros.h>
+#include <mem.h>
 #include <stdlib.h>
 
@@ -53,4 +54,5 @@
 #define NAME "tcp"
 
+/** Maximum amount of data transferred in one send call */
 #define MAX_MSG_SIZE DATA_XFER_LIMIT
 
@@ -67,4 +69,5 @@
 static int tcp_cconn_create(tcp_client_t *, tcp_conn_t *, tcp_cconn_t **);
 
+/** Connection callbacks to tie us to lower layer */
 static tcp_cb_t tcp_service_cb = {
 	.cstate_change = tcp_service_cstate_change,
@@ -72,4 +75,5 @@
 };
 
+/** Sentinel connection callbacks to tie us to lower layer */
 static tcp_cb_t tcp_service_lst_cb = {
 	.cstate_change = tcp_service_lst_cstate_change,
@@ -77,4 +81,10 @@
 };
 
+/** Connection state has changed.
+ *
+ * @param conn      Connection
+ * @param arg       Argument (not used)
+ * @param old_state Previous connection state
+ */
 static void tcp_service_cstate_change(tcp_conn_t *conn, void *arg,
     tcp_cstate_t old_state)
@@ -108,4 +118,10 @@
 }
 
+/** Sentinel connection state has changed.
+ *
+ * @param conn      Connection
+ * @param arg       Argument (not used)
+ * @param old_state Previous connection state
+ */
 static void tcp_service_lst_cstate_change(tcp_conn_t *conn, void *arg,
     tcp_cstate_t old_state)
@@ -169,4 +185,9 @@
 }
 
+/** Received data became available on connection.
+ *
+ * @param conn Connection
+ * @param arg  Client connection
+ */
 static void tcp_service_recv_data(tcp_conn_t *conn, void *arg)
 {
@@ -176,4 +197,8 @@
 }
 
+/** Send 'data' event to client.
+ *
+ * @param cconn Client connection
+ */
 static void tcp_ev_data(tcp_cconn_t *cconn)
 {
@@ -192,4 +217,8 @@
 }
 
+/** Send 'connected' event to client.
+ *
+ * @param cconn Client connection
+ */
 static void tcp_ev_connected(tcp_cconn_t *cconn)
 {
@@ -205,4 +234,8 @@
 }
 
+/** Send 'conn_failed' event to client.
+ *
+ * @param cconn Client connection
+ */
 static void tcp_ev_conn_failed(tcp_cconn_t *cconn)
 {
@@ -218,4 +251,8 @@
 }
 
+/** Send 'conn_reset' event to client.
+ *
+ * @param cconn Client connection
+ */
 static void tcp_ev_conn_reset(tcp_cconn_t *cconn)
 {
@@ -231,5 +268,9 @@
 }
 
-/** New incoming connection */
+/** Send 'new_conn' event to client.
+ *
+ * @param clst Client listener that received the connection
+ * @param cconn New client connection
+ */
 static void tcp_ev_new_conn(tcp_clst_t *clst, tcp_cconn_t *cconn)
 {
@@ -246,4 +287,14 @@
 }
 
+/** Create client connection.
+ *
+ * This effectively adds a connection into a client's namespace.
+ *
+ * @param client TCP client
+ * @param conn   Connection
+ * @param rcconn Place to store pointer to new client connection
+ *
+ * @return EOK on success or ENOMEM if out of memory
+ */
 static int tcp_cconn_create(tcp_client_t *client, tcp_conn_t *conn,
     tcp_cconn_t **rcconn)
@@ -272,4 +323,8 @@
 }
 
+/** Destroy client connection.
+ *
+ * @param cconn Client connection
+ */
 static void tcp_cconn_destroy(tcp_cconn_t *cconn)
 {
@@ -278,4 +333,15 @@
 }
 
+/** Create client listener.
+ *
+ * Create client listener based on sentinel connection.
+ * XXX Implement actual listener in protocol core
+ *
+ * @param client TCP client
+ * @param conn   Sentinel connection
+ * @param rclst  Place to store pointer to new client listener
+ *
+ * @return EOK on success or ENOMEM if out of memory
+ */
 static int tcp_clistener_create(tcp_client_t *client, tcp_conn_t *conn,
     tcp_clst_t **rclst)
@@ -304,4 +370,8 @@
 }
 
+/** Destroy client listener.
+ *
+ * @param clst Client listener
+ */
 static void tcp_clistener_destroy(tcp_clst_t *clst)
 {
@@ -310,4 +380,13 @@
 }
 
+/** Get client connection by ID.
+ *
+ * @param client Client
+ * @param id     Client connection ID
+ * @param rcconn Place to store pointer to client connection
+ *
+ * @return EOK on success, ENOENT if no client connection with the given ID
+ *         is found.
+ */
 static int tcp_cconn_get(tcp_client_t *client, sysarg_t id,
     tcp_cconn_t **rcconn)
@@ -323,4 +402,13 @@
 }
 
+/** Get client listener by ID.
+ *
+ * @param client Client
+ * @param id     Client connection ID
+ * @param rclst  Place to store pointer to client listener
+ *
+ * @return EOK on success, ENOENT if no client listener with the given ID
+ *         is found.
+ */
 static int tcp_clistener_get(tcp_client_t *client, sysarg_t id,
     tcp_clst_t **rclst)
@@ -336,5 +424,14 @@
 }
 
-
+/** Create connection.
+ *
+ * Handle client request to create connection (with parameters unmarshalled).
+ *
+ * @param client   TCP client
+ * @param epp      Endpoint pair
+ * @param rconn_id Place to store ID of new connection
+ *
+ * @return EOK on success or negative error code
+ */
 static int tcp_conn_create_impl(tcp_client_t *client, inet_ep2_t *epp,
     sysarg_t *rconn_id)
@@ -376,4 +473,12 @@
 }
 
+/** Destroy connection.
+ *
+ * Handle client request to destroy connection (with parameters unmarshalled).
+ *
+ * @param client  TCP client
+ * @param conn_id Connection ID
+ * @return EOK on success, ENOENT if no such connection is found
+ */
 static int tcp_conn_destroy_impl(tcp_client_t *client, sysarg_t conn_id)
 {
@@ -393,4 +498,14 @@
 }
 
+/** Create listener.
+ *
+ * Handle client request to create listener (with parameters unmarshalled).
+ *
+ * @param client  TCP client
+ * @param ep      Endpoint
+ * @param rlst_id Place to store ID of new listener
+ *
+ * @return EOK on success or negative error code
+*/
 static int tcp_listener_create_impl(tcp_client_t *client, inet_ep_t *ep,
     sysarg_t *rlst_id)
@@ -430,4 +545,13 @@
 }
 
+/** Destroy listener.
+ *
+ * Handle client request to destroy listener (with parameters unmarshalled).
+ *
+ * @param client TCP client
+ * @param lst_id Listener ID
+ *
+ * @return EOK on success, ENOENT if no such listener is found
+ */
 static int tcp_listener_destroy_impl(tcp_client_t *client, sysarg_t lst_id)
 {
@@ -446,4 +570,13 @@
 }
 
+/** Send FIN.
+ *
+ * Handle client request to send FIN (with parameters unmarshalled).
+ *
+ * @param client  TCP client
+ * @param conn_id Connection ID
+ *
+ * @return EOK on success or negative error code
+ */
 static int tcp_conn_send_fin_impl(tcp_client_t *client, sysarg_t conn_id)
 {
@@ -462,4 +595,13 @@
 }
 
+/** Push connection.
+ *
+ * Handle client request to push connection (with parameters unmarshalled).
+ *
+ * @param client  TCP client
+ * @param conn_id Connection ID
+ *
+ * @return EOK on success or negative error code
+ */
 static int tcp_conn_push_impl(tcp_client_t *client, sysarg_t conn_id)
 {
@@ -478,4 +620,13 @@
 }
 
+/** Reset connection.
+ *
+ * Handle client request to reset connection (with parameters unmarshalled).
+ *
+ * @param client  TCP client
+ * @param conn_id Connection ID
+ *
+ * @return EOK on success or negative error code
+ */
 static int tcp_conn_reset_impl(tcp_client_t *client, sysarg_t conn_id)
 {
@@ -493,4 +644,15 @@
 }
 
+/** Send data over connection..
+ *
+ * Handle client request to send data (with parameters unmarshalled).
+ *
+ * @param client  TCP client
+ * @param conn_id Connection ID
+ * @param data    Data buffer
+ * @param size    Data size in bytes
+ *
+ * @return EOK on success or negative error code
+ */
 static int tcp_conn_send_impl(tcp_client_t *client, sysarg_t conn_id,
     void *data, size_t size)
@@ -510,4 +672,16 @@
 }
 
+/** Receive data from connection.
+ *
+ * Handle client request to receive data (with parameters unmarshalled).
+ *
+ * @param client  TCP client
+ * @param conn_id Connection ID
+ * @param data    Data buffer
+ * @param size    Buffer size in bytes
+ * @param nrecv   Place to store actual number of bytes received
+ *
+ * @return EOK on success or negative error code
+ */
 static int tcp_conn_recv_impl(tcp_client_t *client, sysarg_t conn_id,
     void *data, size_t size, size_t *nrecv)
@@ -540,4 +714,12 @@
 }
 
+/** Create client callback session.
+ *
+ * Handle client request to create callback session.
+ *
+ * @param client  TCP client
+ * @param iid     Async request ID
+ * @param icall   Async request data
+ */
 static void tcp_callback_create_srv(tcp_client_t *client, ipc_callid_t iid,
     ipc_call_t *icall)
@@ -555,4 +737,12 @@
 }
 
+/** Create connection.
+ *
+ * Handle client request to create connection.
+ *
+ * @param client   TCP client
+ * @param iid      Async request ID
+ * @param icall    Async request data
+ */
 static void tcp_conn_create_srv(tcp_client_t *client, ipc_callid_t iid,
     ipc_call_t *icall)
@@ -594,4 +784,12 @@
 }
 
+/** Destroy connection.
+ *
+ * Handle client request to destroy connection.
+ *
+ * @param client   TCP client
+ * @param iid      Async request ID
+ * @param icall    Async request data
+ */
 static void tcp_conn_destroy_srv(tcp_client_t *client, ipc_callid_t iid,
     ipc_call_t *icall)
@@ -607,4 +805,12 @@
 }
 
+/** Create listener.
+ *
+ * Handle client request to create listener.
+ *
+ * @param client   TCP client
+ * @param iid      Async request ID
+ * @param icall    Async request data
+ */
 static void tcp_listener_create_srv(tcp_client_t *client, ipc_callid_t iid,
     ipc_call_t *icall)
@@ -646,4 +852,12 @@
 }
 
+/** Destroy listener.
+ *
+ * Handle client request to destroy listener.
+ *
+ * @param client   TCP client
+ * @param iid      Async request ID
+ * @param icall    Async request data
+ */
 static void tcp_listener_destroy_srv(tcp_client_t *client, ipc_callid_t iid,
     ipc_call_t *icall)
@@ -659,4 +873,12 @@
 }
 
+/** Send FIN.
+ *
+ * Handle client request to send FIN.
+ *
+ * @param client   TCP client
+ * @param iid      Async request ID
+ * @param icall    Async request data
+ */
 static void tcp_conn_send_fin_srv(tcp_client_t *client, ipc_callid_t iid,
     ipc_call_t *icall)
@@ -672,4 +894,12 @@
 }
 
+/** Push connection.
+ *
+ * Handle client request to push connection.
+ *
+ * @param client   TCP client
+ * @param iid      Async request ID
+ * @param icall    Async request data
+ */
 static void tcp_conn_push_srv(tcp_client_t *client, ipc_callid_t iid,
     ipc_call_t *icall)
@@ -685,4 +915,12 @@
 }
 
+/** Reset connection.
+ *
+ * Handle client request to reset connection.
+ *
+ * @param client   TCP client
+ * @param iid      Async request ID
+ * @param icall    Async request data
+ */
 static void tcp_conn_reset_srv(tcp_client_t *client, ipc_callid_t iid,
     ipc_call_t *icall)
@@ -698,4 +936,12 @@
 }
 
+/** Send data via connection..
+ *
+ * Handle client request to send data via connection.
+ *
+ * @param client   TCP client
+ * @param iid      Async request ID
+ * @param icall    Async request data
+ */
 static void tcp_conn_send_srv(tcp_client_t *client, ipc_callid_t iid,
     ipc_call_t *icall)
@@ -750,4 +996,12 @@
 }
 
+/** Read received data from connection without blocking.
+ *
+ * Handle client request to read received data via connection without blocking.
+ *
+ * @param client   TCP client
+ * @param iid      Async request ID
+ * @param icall    Async request data
+ */
 static void tcp_conn_recv_srv(tcp_client_t *client, ipc_callid_t iid,
     ipc_call_t *icall)
@@ -798,4 +1052,12 @@
 }
 
+/** Read received data from connection with blocking.
+ *
+ * Handle client request to read received data via connection with blocking.
+ *
+ * @param client   TCP client
+ * @param iid      Async request ID
+ * @param icall    Async request data
+ */
 static void tcp_conn_recv_wait_srv(tcp_client_t *client, ipc_callid_t iid,
     ipc_call_t *icall)
@@ -851,6 +1113,8 @@
 }
 
-#include <mem.h>
-
+/** Initialize TCP client structure.
+ *
+ * @param client TCP client
+ */
 static void tcp_client_init(tcp_client_t *client)
 {
@@ -861,12 +1125,16 @@
 }
 
+/** Finalize TCP client structure.
+ *
+ * @param client TCP client
+ */
 static void tcp_client_fini(tcp_client_t *client)
 {
 	tcp_cconn_t *cconn;
-	size_t n;
+	unsigned long n;
 
 	n = list_count(&client->cconn);
 	if (n != 0) {
-		log_msg(LOG_DEFAULT, LVL_WARN, "Client with %zu active "
+		log_msg(LOG_DEFAULT, LVL_WARN, "Client with %lu active "
 		    "connections closed session", n);
 
@@ -882,5 +1150,5 @@
 	n = list_count(&client->clst);
 	if (n != 0) {
-		log_msg(LOG_DEFAULT, LVL_WARN, "Client with %zu active "
+		log_msg(LOG_DEFAULT, LVL_WARN, "Client with %lu active "
 		    "listeners closed session", n);
 		/* XXX Destroy listeners */
@@ -891,4 +1159,10 @@
 }
 
+/** Handle TCP client connection.
+ *
+ * @param iid   Connect call ID
+ * @param icall Connect call data
+ * @param arg   Connection argument
+ */
 static void tcp_client_conn(ipc_callid_t iid, ipc_call_t *icall, void *arg)
 {
@@ -961,4 +1235,8 @@
 }
 
+/** Initialize TCP service.
+ *
+ * @return EOK on success or negative error code.
+ */
 int tcp_service_init(void)
 {
@@ -966,5 +1244,5 @@
 	service_id_t sid;
 
-	async_set_client_connection(tcp_client_conn);
+	async_set_fallback_port_handler(tcp_client_conn, NULL);
 
 	rc = loc_server_register(NAME);
Index: uspace/srv/net/tcp/tcp_type.h
===================================================================
--- uspace/srv/net/tcp/tcp_type.h	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/net/tcp/tcp_type.h	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -47,4 +47,5 @@
 struct tcp_conn;
 
+/** Connection state */
 typedef enum {
 	/** Listen */
@@ -101,4 +102,5 @@
 } tcp_error_t;
 
+/** Transfer flags */
 typedef enum {
 	XF_PUSH		= 0x1,
@@ -106,4 +108,8 @@
 } xflags_t;
 
+/** Control message bits
+ *
+ * Note this is not the actual on-the-wire encoding
+ */
 typedef enum {
 	CTL_SYN		= 0x1,
@@ -128,4 +134,5 @@
 } tcp_tqueue_t;
 
+/** Active or passive connection */
 typedef enum {
 	ap_active,
@@ -133,4 +140,5 @@
 } acpass_t;
 
+/** Flags for TCP open operation */
 typedef enum {
 	tcp_open_nonblock = 1
@@ -264,5 +272,5 @@
 } tcp_segment_t;
 
-
+/** Receive queue entry */
 typedef struct {
 	link_t link;
@@ -279,4 +287,5 @@
 } tcp_squeue_entry_t;
 
+/** Incoming queue entry */
 typedef struct {
 	link_t link;
@@ -291,4 +300,9 @@
 } tcp_tqueue_entry_t;
 
+/** Continuation of processing.
+ *
+ * When processing incoming segment, are we done or should we continue
+ * processing it?
+ */
 typedef enum {
 	cp_continue,
Index: uspace/srv/net/udp/service.c
===================================================================
--- uspace/srv/net/udp/service.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/net/udp/service.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -52,12 +52,22 @@
 #define NAME "udp"
 
+/** Maximum message size */
 #define MAX_MSG_SIZE DATA_XFER_LIMIT
 
 static void udp_cassoc_recv_msg(void *, inet_ep2_t *, udp_msg_t *);
 
+/** Callbacks to tie us to association layer */
 static udp_assoc_cb_t udp_cassoc_cb = {
 	.recv_msg = udp_cassoc_recv_msg
 };
 
+/** Add message to client receive queue.
+ *
+ * @param cassoc Client association
+ * @param epp    Endpoint pair on which message was received
+ * @param msg    Message
+ *
+ * @return EOK on success, ENOMEM if out of memory
+ */
 static int udp_cassoc_queue_msg(udp_cassoc_t *cassoc, inet_ep2_t *epp,
     udp_msg_t *msg)
@@ -86,4 +96,8 @@
 }
 
+/** Send 'data' event to client.
+ *
+ * @param client Client
+ */
 static void udp_ev_data(udp_client_t *client)
 {
@@ -99,4 +113,14 @@
 }
 
+/** Create client association.
+ *
+ * This effectively adds an association into a client's namespace.
+ *
+ * @param client  Client
+ * @param assoc   Association
+ * @param rcassoc Place to store pointer to new client association
+ *
+ * @return EOK on soccess, ENOMEM if out of memory
+ */
 static int udp_cassoc_create(udp_client_t *client, udp_assoc_t *assoc,
     udp_cassoc_t **rcassoc)
@@ -125,4 +149,8 @@
 }
 
+/** Destroy client association.
+ *
+ * @param cassoc Client association
+ */
 static void udp_cassoc_destroy(udp_cassoc_t *cassoc)
 {
@@ -131,4 +159,13 @@
 }
 
+/** Get client association by ID.
+ *
+ * @param client  Client
+ * @param id      Client association ID
+ * @param rcassoc Place to store pointer to client association
+ *
+ * @return EOK on success, ENOENT if no client association with the given ID
+ *         is found.
+ */
 static int udp_cassoc_get(udp_client_t *client, sysarg_t id,
     udp_cassoc_t **rcassoc)
@@ -144,4 +181,12 @@
 }
 
+/** Message received on client association.
+ *
+ * Used as udp_assoc_cb.recv_msg callback.
+ *
+ * @param arg Callback argument, client association
+ * @param epp Endpoint pair where message was received
+ * @param msg Message
+ */
 static void udp_cassoc_recv_msg(void *arg, inet_ep2_t *epp, udp_msg_t *msg)
 {
@@ -152,4 +197,14 @@
 }
 
+/** Create association.
+ *
+ * Handle client request to create association (with parameters unmarshalled).
+ *
+ * @param client    UDP client
+ * @param epp       Endpoint pair
+ * @param rassoc_id Place to store ID of new association
+ *
+ * @return EOK on success or negative error code
+ */
 static int udp_assoc_create_impl(udp_client_t *client, inet_ep2_t *epp,
     sysarg_t *rassoc_id)
@@ -189,4 +244,12 @@
 }
 
+/** Destroy association.
+ *
+ * Handle client request to destroy association (with parameters unmarshalled).
+ *
+ * @param client   UDP client
+ * @param assoc_id Association ID
+ * @return EOK on success, ENOENT if no such association is found
+ */
 static int udp_assoc_destroy_impl(udp_client_t *client, sysarg_t assoc_id)
 {
@@ -207,4 +270,17 @@
 }
 
+/** Send message via association.
+ *
+ * Handle client request to send message (with parameters unmarshalled).
+ *
+ * @param client   UDP client
+ * @param assoc_id Association ID
+ * @param dest     Destination endpoint or @c NULL to use the default from
+ *                 association
+ * @param data     Message data
+ * @param size     Message size
+ *
+ * @return EOK on success or negative error code
+ */
 static int udp_assoc_send_msg_impl(udp_client_t *client, sysarg_t assoc_id,
     inet_ep_t *dest, void *data, size_t size)
@@ -227,4 +303,12 @@
 }
 
+/** Create callback session.
+ *
+ * Handle client request to create callback session.
+ *
+ * @param client   UDP client
+ * @param iid      Async request ID
+ * @param icall    Async request data
+ */
 static void udp_callback_create_srv(udp_client_t *client, ipc_callid_t iid,
     ipc_call_t *icall)
@@ -242,4 +326,12 @@
 }
 
+/** Create association.
+ *
+ * Handle client request to create association.
+ *
+ * @param client   UDP client
+ * @param iid      Async request ID
+ * @param icall    Async request data
+ */
 static void udp_assoc_create_srv(udp_client_t *client, ipc_callid_t iid,
     ipc_call_t *icall)
@@ -281,4 +373,12 @@
 }
 
+/** Destroy association.
+ *
+ * Handle client request to destroy association.
+ *
+ * @param client   UDP client
+ * @param iid      Async request ID
+ * @param icall    Async request data
+ */
 static void udp_assoc_destroy_srv(udp_client_t *client, ipc_callid_t iid,
     ipc_call_t *icall)
@@ -294,4 +394,12 @@
 }
 
+/** Send message via association.
+ *
+ * Handle client request to send message.
+ *
+ * @param client   UDP client
+ * @param iid      Async request ID
+ * @param icall    Async request data
+ */
 static void udp_assoc_send_msg_srv(udp_client_t *client, ipc_callid_t iid,
     ipc_call_t *icall)
@@ -368,4 +476,9 @@
 }
 
+/** Get next received message.
+ *
+ * @param client UDP Client
+ * @return Pointer to queue entry for next received message
+ */
 static udp_crcv_queue_entry_t *udp_rmsg_get_next(udp_client_t *client)
 {
@@ -379,4 +492,12 @@
 }
 
+/** Get info on first received message.
+ *
+ * Handle client request to get information on received message.
+ *
+ * @param client   UDP client
+ * @param iid      Async request ID
+ * @param icall    Async request data
+ */
 static void udp_rmsg_info_srv(udp_client_t *client, ipc_callid_t iid,
     ipc_call_t *icall)
@@ -418,4 +539,12 @@
 }
 
+/** Read data from first received message.
+ *
+ * Handle client request to read data from first received message.
+ *
+ * @param client   UDP client
+ * @param iid      Async request ID
+ * @param icall    Async request data
+ */
 static void udp_rmsg_read_srv(udp_client_t *client, ipc_callid_t iid,
     ipc_call_t *icall)
@@ -460,4 +589,13 @@
 }
 
+/** Discard first received message.
+ *
+ * Handle client request to discard first received message, advancing
+ * to the next one.
+ *
+ * @param client   UDP client
+ * @param iid      Async request ID
+ * @param icall    Async request data
+ */
 static void udp_rmsg_discard_srv(udp_client_t *client, ipc_callid_t iid,
     ipc_call_t *icall)
@@ -480,8 +618,14 @@
 }
 
+/** Handle UDP client connection.
+ *
+ * @param iid   Connect call ID
+ * @param icall Connect call data
+ * @param arg   Connection argument
+ */
 static void udp_client_conn(ipc_callid_t iid, ipc_call_t *icall, void *arg)
 {
 	udp_client_t client;
-	size_t n;
+	unsigned long n;
 
 	/* Accept the connection */
@@ -541,5 +685,5 @@
 	if (n != 0) {
 		log_msg(LOG_DEFAULT, LVL_WARN, "udp_client_conn: "
-		    "Client with %zu active associations closed session.", n);
+		    "Client with %lu active associations closed session.", n);
 		/* XXX Clean up */
 	}
@@ -551,4 +695,8 @@
 }
 
+/** Initialize UDP service.
+ *
+ * @return EOK on success or negative error code.
+ */
 int udp_service_init(void)
 {
@@ -556,5 +704,5 @@
 	service_id_t sid;
 
-	async_set_client_connection(udp_client_conn);
+	async_set_fallback_port_handler(udp_client_conn, NULL);
 
 	rc = loc_server_register(NAME);
Index: uspace/srv/net/udp/udp_type.h
===================================================================
--- uspace/srv/net/udp/udp_type.h	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/net/udp/udp_type.h	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -46,4 +46,5 @@
 #define UDP_FRAGMENT_SIZE 65535
 
+/** UDP error codes */
 typedef enum {
 	UDP_EOK,
@@ -84,5 +85,7 @@
 } udp_pdu_t;
 
+/** Association callbacks */
 typedef struct {
+	/** Message received */
 	void (*recv_msg)(void *, inet_ep2_t *, udp_msg_t *);
 } udp_assoc_cb_t;
@@ -124,4 +127,5 @@
 } udp_assoc_status_t;
 
+/** UDP receive queue entry */
 typedef struct {
 	/** Link to receive queue */
@@ -133,4 +137,8 @@
 } udp_rcv_queue_entry_t;
 
+/** UDP client association.
+ *
+ * Ties a UDP association into the namespace of a client
+ */
 typedef struct udp_cassoc {
 	/** Association */
@@ -143,4 +151,5 @@
 } udp_cassoc_t;
 
+/** UDP client receive queue entry */
 typedef struct {
 	/** Link to receive queue */
@@ -154,4 +163,5 @@
 } udp_crcv_queue_entry_t;
 
+/** UDP client */
 typedef struct udp_client {
 	/** Client callback session */
Index: uspace/srv/ns/clonable.c
===================================================================
--- uspace/srv/ns/clonable.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/ns/clonable.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -46,7 +46,8 @@
 typedef struct {
 	link_t link;
-	sysarg_t service;
-	ipc_call_t call;
+	service_t service;
+	iface_t iface;
 	ipc_callid_t callid;
+	sysarg_t arg3;
 } cs_req_t;
 
@@ -61,7 +62,7 @@
 
 /** Return true if @a service is clonable. */
-bool service_clonable(int service)
+bool service_clonable(service_t service)
 {
-	return (service == SERVICE_LOAD);
+	return (service == SERVICE_LOADER);
 }
 
@@ -73,10 +74,8 @@
  *
  */
-void register_clonable(sysarg_t service, sysarg_t phone, ipc_call_t *call,
+void register_clonable(service_t service, sysarg_t phone, ipc_call_t *call,
     ipc_callid_t callid)
 {
-	link_t *req_link;
-
-	req_link = list_first(&cs_req);
+	link_t *req_link = list_first(&cs_req);
 	if (req_link == NULL) {
 		/* There was no pending connection request. */
@@ -90,10 +89,10 @@
 	
 	/* Currently we can only handle a single type of clonable service. */
-	assert(csr->service == SERVICE_LOAD);
+	assert(csr->service == SERVICE_LOADER);
 	
 	ipc_answer_0(callid, EOK);
 	
-	ipc_forward_fast(csr->callid, phone, IPC_GET_ARG2(csr->call),
-	    IPC_GET_ARG3(csr->call), 0, IPC_FF_NONE);
+	ipc_forward_fast(csr->callid, phone, csr->iface, csr->arg3, 0,
+	    IPC_FF_NONE);
 	
 	free(csr);
@@ -104,4 +103,5 @@
  *
  * @param service Service to be connected to.
+ * @param iface   Interface to be connected to.
  * @param call    Pointer to call structure.
  * @param callid  Call ID of the request.
@@ -110,8 +110,8 @@
  *
  */
-void connect_to_clonable(sysarg_t service, ipc_call_t *call,
+void connect_to_clonable(service_t service, iface_t iface, ipc_call_t *call,
     ipc_callid_t callid)
 {
-	assert(service == SERVICE_LOAD);
+	assert(service == SERVICE_LOADER);
 	
 	cs_req_t *csr = malloc(sizeof(cs_req_t));
@@ -132,6 +132,7 @@
 	link_initialize(&csr->link);
 	csr->service = service;
-	csr->call = *call;
+	csr->iface = iface;
 	csr->callid = callid;
+	csr->arg3 = IPC_GET_ARG3(*call);
 	
 	/*
Index: uspace/srv/ns/clonable.h
===================================================================
--- uspace/srv/ns/clonable.h	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/ns/clonable.h	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -36,11 +36,14 @@
 #include <ipc/common.h>
 #include <sys/types.h>
+#include <ipc/services.h>
+#include <abi/ipc/interfaces.h>
 #include <stdbool.h>
 
 extern int clonable_init(void);
 
-extern bool service_clonable(int);
-extern void register_clonable(sysarg_t, sysarg_t, ipc_call_t *, ipc_callid_t);
-extern void connect_to_clonable(sysarg_t, ipc_call_t *, ipc_callid_t);
+extern bool service_clonable(service_t);
+extern void register_clonable(service_t, sysarg_t, ipc_call_t *,
+    ipc_callid_t);
+extern void connect_to_clonable(service_t, iface_t, ipc_call_t *, ipc_callid_t);
 
 #endif
Index: uspace/srv/ns/ns.c
===================================================================
--- uspace/srv/ns/ns.c	(revision 3feeab2bb1fdb0b4062cc7b3e6c493d1552814dc)
+++ uspace/srv/ns/ns.c	(revision ff381a79ad697b23cc01e3f8a66966d2d2cbd7dc)
@@ -38,4 +38,6 @@
 #include <ipc/ipc.h>
 #include <ipc/ns.h>
+#include <ipc/services.h>
+#include <abi/ipc/interfaces.h>
 #include <stdio.h>
 #include <errno.h>
@@ -73,4 +75,8 @@
 		sysarg_t retval;
 		
+		iface_t iface;
+		service_t service;
+		sysarg_t phone;
+		
 		switch (IPC_GET_IMETHOD(call)) {
 		case IPC_M_PHONE_HUNGUP:
@@ -78,27 +84,29 @@
 			break;
 		case IPC_M_CONNECT_TO_ME:
+			service = IPC_GET_ARG2(call);
+			phone = IPC_GET_ARG5(call);
+			
 			/*
 			 * Server requests service registration.
 			 */
-			if (service_clonable(IPC_GET_ARG1(call))) {
-				register_clonable(IPC_GET_ARG1(call),
-				    IPC_GET_ARG5(call), &call, callid);
+			if (service_clonable(service)) {
+				register_clonable(service, phone, &call, callid);
 				continue;
-			} else {
-				retval = register_service(IPC_GET_ARG1(call),
-				    IPC_GET_ARG5(call), &call);
-			}
+			} else
+				retval = register_service(service, phone, &call);
+			
 			break;
 		case IPC_M_CONNECT_ME_TO:
+			iface = IPC_GET_ARG1(call);
+			service = IPC_GET_ARG2(call);
+			
 			/*
 			 * Client requests to be connected to a service.
 			 */
-			if (service_clonable(IPC_GET_ARG1(call))) {
-				connect_to_clonable(IPC_GET_ARG1(call),
-				    &call, callid);
+			if (service_clonable(service)) {
+				connect_to_clonable(service, iface, &call, callid);
 				continue;
 			} else {
-				connect_to_service(IPC_GET_ARG1(call), &call,
-				    callid);
+				connect_to_service(service, iface, &call, callid);
 				continue;
 			}
